// Sketcher3Doc.cpp : implementation of the CSketcher3Doc class
//

#include "stdafx.h"
#include "Sketcher3.h"

#include "Sketcher3Doc.h"
#include "Sketcher3View.h"
#include "constantes.h"
#include "element.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSketcher3Doc

IMPLEMENT_DYNCREATE(CSketcher3Doc, CDocument)

BEGIN_MESSAGE_MAP(CSketcher3Doc, CDocument)
	//{{AFX_MSG_MAP(CSketcher3Doc)
	ON_COMMAND(ID_COLOR_BLACK, OnColorBlack)
	ON_UPDATE_COMMAND_UI(ID_COLOR_BLACK, OnUpdateColorBlack)
	ON_COMMAND(ID_COLOR_BLUE, OnColorBlue)
	ON_UPDATE_COMMAND_UI(ID_COLOR_BLUE, OnUpdateColorBlue)
	ON_COMMAND(ID_COLOR_GREEN, OnColorGreen)
	ON_UPDATE_COMMAND_UI(ID_COLOR_GREEN, OnUpdateColorGreen)
	ON_COMMAND(ID_COLOR_RED, OnColorRed)
	ON_UPDATE_COMMAND_UI(ID_COLOR_RED, OnUpdateColorRed)
	ON_COMMAND(ID_ELEMENT_CERCLE, OnElementCercle)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_CERCLE, OnUpdateElementCercle)
	ON_COMMAND(ID_ELEMENT_CURVE, OnElementCurve)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_CURVE, OnUpdateElementCurve)
	ON_COMMAND(ID_ELEMENT_LINE, OnElementLine)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_LINE, OnUpdateElementLine)
	ON_COMMAND(ID_ELEMENT_RECTANGLE, OnElementRectangle)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_RECTANGLE, OnUpdateElementRectangle)
	ON_COMMAND(ID_INFOS_DESCRIPTIONS, OnInfosDescriptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSketcher3Doc construction/destruction

CSketcher3Doc::CSketcher3Doc()
{
	// Dfinit la couleur de dessin de dpart
	m_Color=BLACK ;

	// Dfinit le type d'lment de dpart
	m_Element = LINE ;

	// Dfinit un pinceau d'un pixel
	m_PenWidth = 0 ;
}

// Destructeur
CSketcher3Doc::~CSketcher3Doc()
{
	// Obtient la position du premier element de la liste
	POSITION aPosition = m_ElementList.GetHeadPosition() ;

	//Supprime l'element de chaque entree de la liste
	while(aPosition) delete m_ElementList.GetNext(aPosition) ;

	// Supprime tous les pointeurs
	m_ElementList.RemoveAll() ;
}

// Ajoute un element  la liste d'elements
void CSketcher3Doc::AddElement(CElement* pElem) 
{
	m_ElementList.AddTail(pElem) ;
}

BOOL CSketcher3Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSketcher3Doc serialization

void CSketcher3Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSketcher3Doc diagnostics

#ifdef _DEBUG
void CSketcher3Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSketcher3Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSketcher3Doc commands

void CSketcher3Doc::OnColorBlack() 
{
	// TODO: Add your command handler code here
	m_Color = BLACK ;
}

void CSketcher3Doc::OnColorBlue() 
{
	// TODO: Add your command handler code here
	m_Color = BLUE ;

}

void CSketcher3Doc::OnColorGreen() 
{
	// TODO: Add your command handler code here
	m_Color =GREEN ;
}

void CSketcher3Doc::OnColorRed() 
{
	// TODO: Add your command handler code here
	m_Color= RED ;
}

void CSketcher3Doc::OnElementCercle() 
{
	// TODO: Add your command handler code here
	m_Element = CERCLE ;
}

void CSketcher3Doc::OnElementCurve() 
{
	// TODO: Add your command handler code here
	m_Element = CURVE ;
	
}

void CSketcher3Doc::OnElementLine() 
{
	// TODO: Add your command handler code here
	m_Element = LINE ;
	
}

void CSketcher3Doc::OnElementRectangle() 
{
	// TODO: Add your command handler code here
	m_Element = RECTANGLE;
	
}

void CSketcher3Doc::OnUpdateColorBlack(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Color==BLACK) ;
}

void CSketcher3Doc::OnUpdateColorBlue(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Color==BLUE) ;
}

void CSketcher3Doc::OnUpdateColorGreen(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Color==GREEN) ;
}

void CSketcher3Doc::OnUpdateColorRed(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Color==RED) ;
}

void CSketcher3Doc::OnUpdateElementCercle(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Element==CERCLE) ;
}

void CSketcher3Doc::OnUpdateElementCurve(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Element==CURVE) ;
}

void CSketcher3Doc::OnUpdateElementRectangle(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Element==RECTANGLE) ;
}

void CSketcher3Doc::OnUpdateElementLine(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Element==LINE) ;
}

void CSketcher3Doc::OnInfosDescriptions() 
{
	// Rcuprer un pointeur sur la vue 
	// 1ere mthode
	//     CSketcher3View *CurrentView = CSketcher3View::GetView() ;
	// 2eme mthode (plus simple)
	POSITION pos = GetFirstViewPosition() ;
	CSketcher3View *CurrentView = static_cast<CSketcher3View *>(GetNextView (pos)) ;

	// Crer un DC et l'associe  la vie courante
	CClientDC aDC(CurrentView) ;

	// Ajuste l'origine
	CurrentView->OnPrepareDC(&aDC) ;
	
	// Convertit le point en coordonnes logiques
	//aDC.DPtoLP(&point) ;

	// Position du premier element de la liste, boucler sur tous les elements
	POSITION aPos = GetListHeadPosition() ;
	CElement* pElem = 0 ;
	while(aPos) {
		pElem = GetNext(aPos) ;
		// Si l'element est visible on le dessine
		if(aDC.RectVisible(pElem->GetBoundRect())) pElem->WriteLabel(&aDC) ;
	}
}
