//------------------------------------------------------------------------
//					CE QUI CONCERNE CCercle
//------------------------------------------------------------------------
#include "stdafx.h"
#include <iostream>
#include <math.h> 
#include "cercle.h"

CCercle::CCercle(CPoint Start,CPoint End,int PenWidth, COLORREF Color): 
CElement(PenWidth, Color) 
{	
	long Radius;
	CRect EnclosingRect;
	
	// Calcule du rayon du cercle
	Radius = static_cast<long>(sqrt(static_cast<double>(
								(End.x-Start.x)*(End.x-Start.x) +
								(End.y-Start.y)*(End.y-Start.y) ) ) );
	
	// Normaliser le Rectangle Dlimiteur
	m_EnclosingRect=CRect(Start.x-Radius, Start.y-Radius, 
						  Start.x+Radius, Start.y+Radius) ;
	m_EnclosingRect.NormalizeRect() ;
}


// Opration de dessin
void CCercle::Draw(CDC* pDC) const 
{
		// Cre une plume associe  l'objet et l'initialise avec 
	// la couleur de l'objet et l'epaisseur du trait
	CPen aPen;
	if(!aPen.CreatePen(PS_SOLID, m_Pen, m_Color)) {
		// Echec de la cration de la plume, Abondon du programme
		AfxMessageBox("Echec du trac d'un cercle", MB_OK) ;
		AfxAbort() ;
	}

	// Selectionne la plume
	CPen* pOldPen = pDC->SelectObject(&aPen) ;

	// Selectionne le pinceau
	CBrush* pOldBrush=static_cast<CBrush*>(pDC->SelectStockObject(NULL_BRUSH));

	// Dessine Maintenant le reclangle
	pDC->Ellipse(m_EnclosingRect) ;
	
	// Restitue l'ancienne plume et l'ancien pinceau
	pDC->SelectObject(pOldPen) ;
	pDC->SelectObject(pOldBrush) ;
}

void CCercle::WriteLabel(CDC* pDC)  const 
{
	// LOGFONT pour regler les attributs de ma police
	LOGFONT LogFnt;
	ZeroMemory(&LogFnt, sizeof(LOGFONT)) ;
	LogFnt.lfItalic=TRUE ;
	LogFnt.lfWidth=m_Pen ;
	LogFnt.lfWeight=FW_BOLD ;

	// Crer puis slectionner la police
	CFont MyFnt ;
	MyFnt.CreateFontIndirect(&LogFnt) ;
	CFont* pOldFont = pDC->SelectObject(&MyFnt) ;
	
	// La couleur 
	COLORREF OldColor = pDC->SetTextColor(m_Color) ;

	// Dessine le texte
	CPoint pt = m_EnclosingRect.CenterPoint( ) ; 
	pDC->TextOut(pt.x, pt.y, "CERCLE") ; 

	// Restitue les anciennes couleur et police au DC
	pDC->SelectObject(pOldFont) ;
	pDC->SetTextColor(OldColor) ;
}


