//------------------------------------------------------------------------
//					CE QUI CONCERNE CCourbe
//------------------------------------------------------------------------
#include "stdafx.h"

#include <iostream>
#include "curve.h"

// Constructeur

CCurve::CCurve(const CPoint& First, const CPoint& Second,int Pen, const COLORREF& Color): 
				CElement(Pen,Color,CRect(First, Second))
{
	m_PointList.AddTail(First) ;
	m_PointList.AddTail(Second) ;
}

// Ajoute un segment  la courbe
void CCurve::AddSegment(const CPoint& Point) 
{
	// Ajoute le point en fin de liste
	m_PointList.AddTail(Point) ;

	// Recalcule le rectangle delimiteur
	m_EnclosingRect = CRect(min(m_EnclosingRect.left, Point.x) ,
							min(m_EnclosingRect.top, Point.y) ,
							max(m_EnclosingRect.right, Point.x) ,
							max(m_EnclosingRect.bottom, Point.y) 
							) ;
}

// Dessine un objet de type CCurve
void CCurve::Draw(CDC* pDC) const 
{
	//Cre une plume associe  l'objet et l'initialise avec 
	//la couleur de l'objet et l'epaisseur du trait
	CPen aPen;
	if(!aPen.CreatePen(PS_SOLID, m_Pen, m_Color)) {
		//Echec de la cration de la plume, Abondon du programme
		AfxMessageBox("Echec du trac d'une courbe", MB_OK) ;
		AfxAbort() ;
	}

	// Selectionne la plume
	CPen* pOldPen = pDC->SelectObject(&aPen) ;

	// Position du premier point de la courbe
	POSITION aPosition = m_PointList.GetHeadPosition() ;

	// Si la position est correcte se deplacer  ce point
	if(aPosition)  pDC->MoveTo(m_PointList.GetNext(aPosition)) ;

	// Boucle sur tous les points de le courbe
	while(aPosition) pDC->LineTo(m_PointList.GetNext(aPosition)) ;

	// Restitue l'ancienne plume
	pDC->SelectObject(pOldPen) ;
}


void CCurve::WriteLabel(CDC* pDC)  const 
{
    // LOGFONT pour regler les attributs de ma police
	LOGFONT LogFnt;
	ZeroMemory(&LogFnt, sizeof(LOGFONT)) ;
	LogFnt.lfItalic=TRUE ;
	LogFnt.lfWidth=m_Pen ;
	LogFnt.lfWeight=FW_BOLD ;

	// Crer puis slectionner la police
	CFont MyFnt ;
	MyFnt.CreateFontIndirect(&LogFnt) ;
	CFont* pOldFont = pDC->SelectObject(&MyFnt) ;
	
	// La couleur 
	COLORREF OldColor = pDC->SetTextColor(m_Color) ;

	// Dessine le texte
	// Position du premier point de la courbe
	POSITION aPosition = m_PointList.GetHeadPosition() ;

	// Si la position est correcte obtenir ce point
	CPoint pt ;
	if(aPosition) pt= m_PointList.GetNext(aPosition) ;
	pDC->TextOut(pt.x, pt.y, "COURBE") ; 

	// Restitue les anciennes couleur et police au DC
	pDC->SelectObject(pOldFont) ;
	pDC->SetTextColor(OldColor) ;
}

