//------------------------------------------------------------------------
//					CE QUI CONCERNE CLine
//------------------------------------------------------------------------
#include "stdafx.h"
#include <iostream>
#include "line.h"


// Constructeur de la classe CLine
CLine::CLine(CPoint Start, CPoint End,int PenWidth, COLORREF Color) : 
CElement(PenWidth, Color, CRect(Start, End) )
{	
	m_StartPoint = Start ;
	m_EndPoint = End ;
}

// Dessine un objet de type CLine
void CLine::Draw(CDC* pDC) const 
{	
	//Cre une plume associe  l'objet et l'initialise avec 
	//la couleur de l'objet et l'epaisseur du trait
	CPen aPen;
	if(!aPen.CreatePen(PS_SOLID, m_Pen, m_Color)) {
		//Echec de la cration de la plume, Abondon du programme
		AfxMessageBox("Echec du trac d'une ligne", MB_OK) ;
		AfxAbort() ;
	}

	// Selectionne la plume
	CPen* pOldPen = pDC->SelectObject(&aPen) ;

	// Dessine
	pDC->MoveTo(m_StartPoint) ;
	pDC->LineTo(m_EndPoint) ;
	
	// Restitue l'ancienne plume
	pDC->SelectObject(pOldPen) ;
}

void CLine::WriteLabel(CDC* pDC)  const 
{
	// LOGFONT pour regler les attributs de ma police
	LOGFONT LogFnt;
	ZeroMemory(&LogFnt, sizeof(LOGFONT)) ;
	LogFnt.lfItalic=TRUE ;
	LogFnt.lfWidth=m_Pen ;
	LogFnt.lfWeight=700 ;

	// Crer puis slectionner la police
	CFont MyFnt ;
	MyFnt.CreateFontIndirect(&LogFnt) ;
	CFont* pOldFont = pDC->SelectObject(&MyFnt) ;
	
	// La couleur 
	COLORREF OldColor = pDC->SetTextColor(m_Color) ;

	// Dessine le texte
	pDC->TextOut(m_StartPoint.x, m_StartPoint.y, "LINE") ; 

	// Restitue les anciennes couleur et police au DC
	pDC->SelectObject(pOldFont) ;
	pDC->SetTextColor(OldColor) ;
}


