//------------------------------------------------------------------------
//					CE QUI CONCERNE CRectangle
//------------------------------------------------------------------------
#include "stdafx.h"
#include <iostream>
#include "rectangle.h"

CRectangle::CRectangle(CPoint Start,CPoint End,int PenWidth, COLORREF Color): 
CElement(PenWidth, Color, CRect(Start, End)) {}

// Dessine un objet de type CRectangle
void CRectangle::Draw(CDC* pDC) const 
{
	// Cre une plume associe  l'objet et l'initialise avec 
	// la couleur de l'objet et l'epaisseur du trait
	CPen aPen;
	if(!aPen.CreatePen(PS_SOLID, m_Pen, m_Color)) {
		// Echec de la cration de la plume, Abondon du programme
		AfxMessageBox("Echec du trac d'un rectangle", MB_OK) ;
		AfxAbort() ;
	}

	// Selectionne la plume
	CPen* pOldPen = pDC->SelectObject(&aPen) ;

	// Selectionne le pinceau
	CBrush* pOldBrush=static_cast<CBrush*>(pDC->SelectStockObject(NULL_BRUSH));

	// Dessine Maintenant le reclangle
	pDC->Rectangle(m_EnclosingRect) ;
	
	// Restitue l'ancienne plume et l'ancien pinceau
	pDC->SelectObject(pOldPen) ;
	pDC->SelectObject(pOldBrush) ;
}

void CRectangle::WriteLabel(CDC* pDC)  const 
{
	// LOGFONT pour regler les attributs de ma police
	LOGFONT LogFnt;
	ZeroMemory(&LogFnt, sizeof(LOGFONT)) ;
	LogFnt.lfItalic=TRUE ;
	LogFnt.lfWidth=m_Pen ;
	LogFnt.lfWeight=FW_BOLD ;

	// Crer puis slectionner la police
	CFont MyFnt ;
	MyFnt.CreateFontIndirect(&LogFnt) ;
	CFont* pOldFont = pDC->SelectObject(&MyFnt) ;
	
	// La couleur 
	COLORREF OldColor = pDC->SetTextColor(m_Color) ;

	// Dessine le texte
	CPoint pt = m_EnclosingRect.TopLeft( ) ;
	pDC->TextOut(pt.x, pt.y-20, "RECTANGLE") ; 

	// Restitue les anciennes couleur et police au DC
	pDC->SelectObject(pOldFont) ;
	pDC->SetTextColor(OldColor) ;
}
